#ifndef DRIVER_MID_H
#define DRIVER_MID_H


//#include "types.h"

typedef int MYHDEVICE;
//#define MYHDEVICE HANDLE

/** s2226 opens the driver middleware helper module
 */
//void s2226_open();
/** s2226 closes the driver middleware helper module
 */
//void s2226_close();

/** Write data to address.  Data is currently 16 bits.
 *  @param drv_handle handle to device 
 *  @param addr register address to write to
 *  @param data data to write
 *  @return 0 on success, -ve otherwise
 */
int s2226_write_data(MYHDEVICE drv_handle, int reg_addr, unsigned short reg_data );
/* same as s2226_write_data but for burst of data at set address. length should be even number */
int s2226_write_data_burst(MYHDEVICE devId, int addr, unsigned char *data, int len);

// addr, data, addr, data interleaved
int s2226_write_addrdata_burst(MYHDEVICE devId, int addr, unsigned char *data, int len);

/** read address data.  currently data is always 16 bits 
 *  @param drv_handle handle to device 
 *  @param reg_addr register address to read in FPGA
 *  @param reg_data pointer to data variable to read into
 *  @return 0 on success, -ve otherwise
 */
int s2226_read_addr_data( MYHDEVICE drv_handle, int reg_addr, unsigned short *reg_data );
/* same as s2226_read_addr_data but for burst of data. length should be an even number */
int s2226_read_addr_data_burst(MYHDEVICE devId, int addr, unsigned char *data, int len);
// same as above, but less calls to the driver
int s2226_read_addr_data_burst2(MYHDEVICE devId, int addr, unsigned char *data, int len);


/** writes burst data to the FPGA address
 * @param drv_handle 
 * @param reg_addr is the register written
 * @param buf is thepointer to buffer
 * @param bytecount is the buffer size
 * @param type (0== normal, 1==consecutive addr/data in the buffer( ALE enabled every other byte))
 * @return none
 */
void s2226_BurstWriteTransfer( MYHDEVICE drv_handle, int reg_addr, void *buf, int bytecount, int type );

/** read burst data from FPGA address
 *  @param reg_addr, address to read from
 *  @param buf, pointer to buffer
 *  @param bytecount number of bytes desired
 *  @return number of bytes read
 */
int s2226_BurstReadTransfer( MYHDEVICE drv_handle, int reg_addr, void *buf, int bytecount );


/** s2226_BurstRawReadTransfer 
 * Read burst with byte ordering for snapshot
 *  @param reg_addr, address to read from
 *  @param buf, pointer to buffer
 *  @param bytecount number of bytes desired
 *  @return number of bytes read
 */
int s2226_BurstRawReadTransfer( MYHDEVICE drv_handle, int reg_addr, void *buf, int bytecount );


int s2226_snapctrl(MYHDEVICE drv_handle, int val);


int s2226_read_addr_data(int handle, int addr, unsigned short *value);
int s2226_read_addr_data_burst(MYHDEVICE devId, int addr, unsigned char *data, int len);
int s2226_write_addr_data_burst(MYHDEVICE devId, int addr, unsigned char *data, int len, int bFast);

int s2226_write_addr_data_interleaved(int handle, int addr, unsigned char *data, int len);
void s2226_BurstWriteTransferFast( MYHDEVICE drv_handle, int addr, void *pbuf, int bytecount, int type );
#endif
