#include <stdio.h>
#include <stdlib.h>
#include <time.h>



int timeval_subtract(result, x, y)
     struct timespec *result, *x, *y;
{
  /* Perform the carry for the later subtraction by updating y. */
    if (x->tv_nsec < y->tv_nsec) {
        int nsec = (y->tv_nsec - x->tv_nsec) / 1000000000 + 1;
        y->tv_nsec -= 1000000 * 1000 * nsec;
        y->tv_sec += nsec;
    }
    if (x->tv_nsec - y->tv_nsec > 1000000) {
        int nsec = (x->tv_nsec - y->tv_nsec) / 1000000000;
        y->tv_nsec += 1000000*1000 * nsec;
        y->tv_sec -= nsec;
    }

  /* Compute the time remaining to wait.
     tv_nsec is certainly positive. */
  result->tv_sec = x->tv_sec - y->tv_sec;
  result->tv_nsec = x->tv_nsec - y->tv_nsec;

  /* Return 1 if result is negative. */
  return x->tv_sec < y->tv_sec;
}

void current_time(struct timespec *ts)
{
    clock_gettime(CLOCK_MONOTONIC, ts);
}

// elapsed time in ms
unsigned long long elapsed_time(struct timespec *ts)
{
    struct timespec cur;
    struct timespec diff;
    clock_gettime(CLOCK_MONOTONIC, &cur);
    timeval_subtract(&diff, &cur, ts);
    return ((diff.tv_sec * 1000) + (diff.tv_nsec / 1000000));
}
